// asyncclientDlg.h : header file
//

#if !defined(AFX_ASYNCCLIENTDLG_H__1CBBF127_FFDD_11D2_8DCE_0000C06B6ED6__INCLUDED_)
#define AFX_ASYNCCLIENTDLG_H__1CBBF127_FFDD_11D2_8DCE_0000C06B6ED6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "async.h" 

class CDemoClass; // forward

/////////////////////////////////////////////////////////////////////////////
// CAsyncclientDlg dialog

class CAsyncclientDlg : public CDialog
{
// Construction
public:
	CAsyncclientDlg(CWnd* pParent = NULL);	// standard constructor
  ~CAsyncclientDlg();

// Dialog Data
	//{{AFX_DATA(CAsyncclientDlg)
	enum { IDD = IDD_ASYNCCLIENT_DIALOG };
	CString	m_sReturn;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAsyncclientDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CDemoClass* m_pDemoClass;

	// Generated message map functions
	//{{AFX_MSG(CAsyncclientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDisplaymessageButton();
	afx_msg void OnAsyncButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
// Operations
public:
	void OnDemoNotify(); 

};

//////////////////////////////////////////////////////////////////////
// CDemoClass sample class used in this demo

class CDemoClass :public CAsyncClass
{
	// Construction
public:
	CDemoClass(CAsyncclientDlg* pOwner)
		:CAsyncClass() 
	{
		m_pOwner=pOwner; 
	}

// Attributes
private:
	_bstr_t				m_bstrData;
	CAsyncclientDlg*	m_pOwner;

// Operations
public:
	_bstr_t&	GetData()					{ return m_bstrData;	}	
	void		SetData(_bstr_t& bstr)	{ m_bstrData=bstr;	}	

// Operations
public:
	void OnNotifyComplete()
	{
		m_pOwner->OnDemoNotify();	
	}
		
	void OnRequestData()
	{
		try
		{
			IasyncProducerPtr p(_T("Asyncserver.asyncProducer.1"));
			SetData(p->GetAsyncData());	
		}
		catch(_com_error &e)
		{
			SetError(e.Error());
		}
	}
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ASYNCCLIENTDLG_H__1CBBF127_FFDD_11D2_8DCE_0000C06B6ED6__INCLUDED_)
